import sys

try:
    import psyco
    psyco.full()
except:
    pass

def square(a):
    return a * a

def double(a):
    return a + a

def apply(f, x):
    pass
    return f(x)

def isAnagram(s1, s2):
    s1 = list(s1)
    s2 = list(s2)
    s1.sort()
    s2.sort()
    return s1 == s2

def countChars(s):
    ret = {}
    for char in s:
        ret[char] = ret.get(char, 0) + 1
    return ret

def isAnagram2(s1, s2):
    # Lets count up the number of times that each character in s1 appears:
    s1 = countChars(s1)
    s2 = countChars(s2)
    return s1 == s2

def isAnagram3(s1, s2):
    s1 = list(s1)
    s2 = list(s2)

    for char in s1:
        if char not in s2:
            return False
        s2[s2.index(char)] = None

    for val in s2:
        if val != None:
            return False

    return True

try:
    print double(1)
    print double("abc")
    print double(double)
except:
    print "There was a problem."

print "Apply double to 5", apply(double, 5)


n = 10
while n:
    n -= 1
    print n

print "Finding anagrams of", sys.argv[1], "and writing those to", sys.argv[2]
of = open(sys.argv[2], 'w')
for line in open("/usr/share/dict/words"):
    s = line.strip()
    if isAnagram2(sys.argv[1], s):
        print s
        print >>of, s

of.close()


